Index: palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3917)
+++ palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3918)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Set green fraction to zero also at vertical surfaces
+! 
+! 3914 2019-04-17 16:02:02Z suehring
 ! In order to obtain correct surface temperature during spinup set window 
 ! fraction to zero (only during spinup) instead of just disabling
@@ -4459,22 +4462,22 @@
                  surf_usm_h%lai(m)  = building_pars_f%pars_xy(ind_lai_r,j,i)
 
-              IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
-                   building_pars_f%fill )  THEN
-                 surf_usm_h%rho_c_wall(nzb_wall,m)   =                         &
-                                    building_pars_f%pars_xy(ind_hc1,j,i)  
-                 surf_usm_h%rho_c_wall(nzb_wall+1,m) =                         &
-                                    building_pars_f%pars_xy(ind_hc1,j,i)
-              ENDIF
-              
-              
-              IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=                     &
-                   building_pars_f%fill )                                      &
-                 surf_usm_h%rho_c_wall(nzb_wall+2,m) =                         &
-                                    building_pars_f%pars_xy(ind_hc2,j,i)
-                 
-              IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=                     &
-                   building_pars_f%fill )                                      &
-                 surf_usm_h%rho_c_wall(nzb_wall+3,m) =                         &
-                                    building_pars_f%pars_xy(ind_hc3,j,i)
+!               IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
+!                    building_pars_f%fill )  THEN
+!                  surf_usm_h%rho_c_wall(nzb_wall,m)   =                         &
+!                                     building_pars_f%pars_xy(ind_hc1,j,i)  
+!                  surf_usm_h%rho_c_wall(nzb_wall+1,m) =                         &
+!                                     building_pars_f%pars_xy(ind_hc1,j,i)
+!               ENDIF
+!               
+!               
+!               IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=                     &
+!                    building_pars_f%fill )                                      &
+!                  surf_usm_h%rho_c_wall(nzb_wall+2,m) =                         &
+!                                     building_pars_f%pars_xy(ind_hc2,j,i)
+!                  
+!               IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=                     &
+!                    building_pars_f%fill )                                      &
+!                  surf_usm_h%rho_c_wall(nzb_wall+3,m) =                         &
+!                                     building_pars_f%pars_xy(ind_hc3,j,i)
                  
               IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
@@ -4495,20 +4498,20 @@
                                     building_pars_f%pars_xy(ind_hc3,j,i)
                  
-              IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
-                   building_pars_f%fill )  THEN 
-                 surf_usm_h%rho_c_window(nzb_wall,m)   =                       &
-                                    building_pars_f%pars_xy(ind_hc1,j,i)  
-                 surf_usm_h%rho_c_window(nzb_wall+1,m) =                       &
-                                    building_pars_f%pars_xy(ind_hc1,j,i)
-              ENDIF
-              IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=                     &
-                   building_pars_f%fill )                                      &
-                 surf_usm_h%rho_c_window(nzb_wall+2,m) =                       &
-                                    building_pars_f%pars_xy(ind_hc2,j,i)
-                 
-              IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=                     &
-                   building_pars_f%fill )                                      &
-                 surf_usm_h%rho_c_window(nzb_wall+3,m) =                       &
-                                    building_pars_f%pars_xy(ind_hc3,j,i)
+!               IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
+!                    building_pars_f%fill )  THEN 
+!                  surf_usm_h%rho_c_window(nzb_wall,m)   =                       &
+!                                     building_pars_f%pars_xy(ind_hc1,j,i)  
+!                  surf_usm_h%rho_c_window(nzb_wall+1,m) =                       &
+!                                     building_pars_f%pars_xy(ind_hc1,j,i)
+!               ENDIF
+!               IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=                     &
+!                    building_pars_f%fill )                                      &
+!                  surf_usm_h%rho_c_window(nzb_wall+2,m) =                       &
+!                                     building_pars_f%pars_xy(ind_hc2,j,i)
+!                  
+!               IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=                     &
+!                    building_pars_f%fill )                                      &
+!                  surf_usm_h%rho_c_window(nzb_wall+3,m) =                       &
+!                                     building_pars_f%pars_xy(ind_hc3,j,i)
 
               IF ( building_pars_f%pars_xy(ind_tc1,j,i) /=                     &
@@ -4751,22 +4754,22 @@
                                        building_pars_f%pars_xy(ind_lai_w,j,i)
                     
-                    IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
-                         building_pars_f%fill )  THEN
-                       surf_usm_v(l)%rho_c_wall(nzb_wall,m)   =                &
-                                          building_pars_f%pars_xy(ind_hc1,j,i) 
-                       surf_usm_v(l)%rho_c_wall(nzb_wall+1,m) =                &
-                                          building_pars_f%pars_xy(ind_hc1,j,i)
-                    ENDIF
-                    
-                    
-                    IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=               &
-                         building_pars_f%fill )                                &
-                       surf_usm_v(l)%rho_c_wall(nzb_wall+2,m) =                &
-                                          building_pars_f%pars_xy(ind_hc2,j,i)
-                       
-                    IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=               &         
-                         building_pars_f%fill )                                &
-                       surf_usm_v(l)%rho_c_wall(nzb_wall+3,m) =                &
-                                          building_pars_f%pars_xy(ind_hc3,j,i)
+!                     IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
+!                          building_pars_f%fill )  THEN
+!                        surf_usm_v(l)%rho_c_wall(nzb_wall,m)   =                &
+!                                           building_pars_f%pars_xy(ind_hc1,j,i) 
+!                        surf_usm_v(l)%rho_c_wall(nzb_wall+1,m) =                &
+!                                           building_pars_f%pars_xy(ind_hc1,j,i)
+!                     ENDIF
+!                     
+!                     
+!                     IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=               &
+!                          building_pars_f%fill )                                &
+!                        surf_usm_v(l)%rho_c_wall(nzb_wall+2,m) =                &
+!                                           building_pars_f%pars_xy(ind_hc2,j,i)
+!                        
+!                     IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=               &         
+!                          building_pars_f%fill )                                &
+!                        surf_usm_v(l)%rho_c_wall(nzb_wall+3,m) =                &
+!                                           building_pars_f%pars_xy(ind_hc3,j,i)
                        
                     IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
@@ -4787,20 +4790,20 @@
                                           building_pars_f%pars_xy(ind_hc3,j,i)
                        
-                    IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
-                         building_pars_f%fill )  THEN 
-                       surf_usm_v(l)%rho_c_window(nzb_wall,m)   =              &
-                                          building_pars_f%pars_xy(ind_hc1,j,i) 
-                       surf_usm_v(l)%rho_c_window(nzb_wall+1,m) =              &
-                                          building_pars_f%pars_xy(ind_hc1,j,i)
-                    ENDIF
-                    IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=               &
-                         building_pars_f%fill )                                &
-                       surf_usm_v(l)%rho_c_window(nzb_wall+2,m) =              &
-                                          building_pars_f%pars_xy(ind_hc2,j,i)
-                       
-                    IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=               &
-                         building_pars_f%fill )                                &
-                       surf_usm_v(l)%rho_c_window(nzb_wall+3,m) =              &
-                                          building_pars_f%pars_xy(ind_hc3,j,i)
+!                     IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
+!                          building_pars_f%fill )  THEN 
+!                        surf_usm_v(l)%rho_c_window(nzb_wall,m)   =              &
+!                                           building_pars_f%pars_xy(ind_hc1,j,i) 
+!                        surf_usm_v(l)%rho_c_window(nzb_wall+1,m) =              &
+!                                           building_pars_f%pars_xy(ind_hc1,j,i)
+!                     ENDIF
+!                     IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=               &
+!                          building_pars_f%fill )                                &
+!                        surf_usm_v(l)%rho_c_window(nzb_wall+2,m) =              &
+!                                           building_pars_f%pars_xy(ind_hc2,j,i)
+!                        
+!                     IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=               &
+!                          building_pars_f%fill )                                &
+!                        surf_usm_v(l)%rho_c_window(nzb_wall+3,m) =              &
+!                                           building_pars_f%pars_xy(ind_hc3,j,i)
                     
                     IF ( building_pars_f%pars_xy(ind_tc1,j,i) /=               &
@@ -5047,7 +5050,18 @@
        DO  m = 1, surf_usm_h%ns
           IF ( surf_usm_h%frac(ind_pav_green,m) > 0.0_wp )  THEN
+             surf_usm_h%frac(ind_veg_wall,m)  = surf_usm_h%frac(ind_veg_wall,m)&
+                                              + surf_usm_h%frac(ind_pav_green,m)
              surf_usm_h%frac(ind_pav_green,m) = 0.0_wp
-             surf_usm_h%frac(ind_veg_wall,m)  = 1.0_wp
           ENDIF
+       ENDDO
+       DO  l = 0, 3
+          DO  m = 1, surf_usm_v(l)%ns
+             IF ( surf_usm_v(l)%frac(ind_pav_green,m) > 0.0_wp )  THEN
+                surf_usm_v(l)%frac(ind_veg_wall,m)  =                          &
+                                             surf_usm_v(l)%frac(ind_veg_wall,m)&
+                                           + surf_usm_v(l)%frac(ind_pav_green,m)
+                surf_usm_v(l)%frac(ind_pav_green,m) = 0.0_wp
+             ENDIF
+          ENDDO
        ENDDO
 
Index: palm/trunk/TESTS/cases/urban_environment/case_config.yml
===================================================================
--- palm/trunk/TESTS/cases/urban_environment/case_config.yml	(revision 3917)
+++ palm/trunk/TESTS/cases/urban_environment/case_config.yml	(revision 3918)
@@ -7,5 +7,4 @@
 
 allowed_number_of_cores:
-  - 1
   - 2
   - 4
Index: palm/trunk/TESTS/cases/urban_environment_restart/case_config.yml
===================================================================
--- palm/trunk/TESTS/cases/urban_environment_restart/case_config.yml	(revision 3917)
+++ palm/trunk/TESTS/cases/urban_environment_restart/case_config.yml	(revision 3918)
@@ -7,5 +7,4 @@
 
 allowed_number_of_cores:
-  - 1
   - 2
   - 4