Index: /palm/trunk/SOURCE/urban_surface_mod.f90
===================================================================
--- /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3920)
+++ /palm/trunk/SOURCE/urban_surface_mod.f90	(revision 3921)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! Undo accidentally commented initialization  
+! 
+! 3918 2019-04-18 13:33:11Z suehring
 ! Set green fraction to zero also at vertical surfaces
 ! 
@@ -4462,22 +4465,22 @@
                  surf_usm_h%lai(m)  = building_pars_f%pars_xy(ind_lai_r,j,i)
 
-!               IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
-!                    building_pars_f%fill )  THEN
-!                  surf_usm_h%rho_c_wall(nzb_wall,m)   =                         &
-!                                     building_pars_f%pars_xy(ind_hc1,j,i)  
-!                  surf_usm_h%rho_c_wall(nzb_wall+1,m) =                         &
-!                                     building_pars_f%pars_xy(ind_hc1,j,i)
-!               ENDIF
-!               
-!               
-!               IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=                     &
-!                    building_pars_f%fill )                                      &
-!                  surf_usm_h%rho_c_wall(nzb_wall+2,m) =                         &
-!                                     building_pars_f%pars_xy(ind_hc2,j,i)
-!                  
-!               IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=                     &
-!                    building_pars_f%fill )                                      &
-!                  surf_usm_h%rho_c_wall(nzb_wall+3,m) =                         &
-!                                     building_pars_f%pars_xy(ind_hc3,j,i)
+              IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
+                   building_pars_f%fill )  THEN
+                 surf_usm_h%rho_c_wall(nzb_wall,m)   =                         &
+                                    building_pars_f%pars_xy(ind_hc1,j,i)  
+                 surf_usm_h%rho_c_wall(nzb_wall+1,m) =                         &
+                                    building_pars_f%pars_xy(ind_hc1,j,i)
+              ENDIF
+              
+              
+              IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=                     &
+                   building_pars_f%fill )                                      &
+                 surf_usm_h%rho_c_wall(nzb_wall+2,m) =                         &
+                                    building_pars_f%pars_xy(ind_hc2,j,i)
+                 
+              IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=                     &
+                   building_pars_f%fill )                                      &
+                 surf_usm_h%rho_c_wall(nzb_wall+3,m) =                         &
+                                    building_pars_f%pars_xy(ind_hc3,j,i)
                  
               IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
@@ -4498,20 +4501,20 @@
                                     building_pars_f%pars_xy(ind_hc3,j,i)
                  
-!               IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
-!                    building_pars_f%fill )  THEN 
-!                  surf_usm_h%rho_c_window(nzb_wall,m)   =                       &
-!                                     building_pars_f%pars_xy(ind_hc1,j,i)  
-!                  surf_usm_h%rho_c_window(nzb_wall+1,m) =                       &
-!                                     building_pars_f%pars_xy(ind_hc1,j,i)
-!               ENDIF
-!               IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=                     &
-!                    building_pars_f%fill )                                      &
-!                  surf_usm_h%rho_c_window(nzb_wall+2,m) =                       &
-!                                     building_pars_f%pars_xy(ind_hc2,j,i)
-!                  
-!               IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=                     &
-!                    building_pars_f%fill )                                      &
-!                  surf_usm_h%rho_c_window(nzb_wall+3,m) =                       &
-!                                     building_pars_f%pars_xy(ind_hc3,j,i)
+              IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=                     &
+                   building_pars_f%fill )  THEN 
+                 surf_usm_h%rho_c_window(nzb_wall,m)   =                       &
+                                    building_pars_f%pars_xy(ind_hc1,j,i)  
+                 surf_usm_h%rho_c_window(nzb_wall+1,m) =                       &
+                                    building_pars_f%pars_xy(ind_hc1,j,i)
+              ENDIF
+              IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=                     &
+                   building_pars_f%fill )                                      &
+                 surf_usm_h%rho_c_window(nzb_wall+2,m) =                       &
+                                    building_pars_f%pars_xy(ind_hc2,j,i)
+                 
+              IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=                     &
+                   building_pars_f%fill )                                      &
+                 surf_usm_h%rho_c_window(nzb_wall+3,m) =                       &
+                                    building_pars_f%pars_xy(ind_hc3,j,i)
 
               IF ( building_pars_f%pars_xy(ind_tc1,j,i) /=                     &
@@ -4754,22 +4757,22 @@
                                        building_pars_f%pars_xy(ind_lai_w,j,i)
                     
-!                     IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
-!                          building_pars_f%fill )  THEN
-!                        surf_usm_v(l)%rho_c_wall(nzb_wall,m)   =                &
-!                                           building_pars_f%pars_xy(ind_hc1,j,i) 
-!                        surf_usm_v(l)%rho_c_wall(nzb_wall+1,m) =                &
-!                                           building_pars_f%pars_xy(ind_hc1,j,i)
-!                     ENDIF
-!                     
-!                     
-!                     IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=               &
-!                          building_pars_f%fill )                                &
-!                        surf_usm_v(l)%rho_c_wall(nzb_wall+2,m) =                &
-!                                           building_pars_f%pars_xy(ind_hc2,j,i)
-!                        
-!                     IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=               &         
-!                          building_pars_f%fill )                                &
-!                        surf_usm_v(l)%rho_c_wall(nzb_wall+3,m) =                &
-!                                           building_pars_f%pars_xy(ind_hc3,j,i)
+                    IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
+                         building_pars_f%fill )  THEN
+                       surf_usm_v(l)%rho_c_wall(nzb_wall,m)   =                &
+                                          building_pars_f%pars_xy(ind_hc1,j,i) 
+                       surf_usm_v(l)%rho_c_wall(nzb_wall+1,m) =                &
+                                          building_pars_f%pars_xy(ind_hc1,j,i)
+                    ENDIF
+                    
+                    
+                    IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=               &
+                         building_pars_f%fill )                                &
+                       surf_usm_v(l)%rho_c_wall(nzb_wall+2,m) =                &
+                                          building_pars_f%pars_xy(ind_hc2,j,i)
+                       
+                    IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=               &         
+                         building_pars_f%fill )                                &
+                       surf_usm_v(l)%rho_c_wall(nzb_wall+3,m) =                &
+                                          building_pars_f%pars_xy(ind_hc3,j,i)
                        
                     IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
@@ -4790,20 +4793,20 @@
                                           building_pars_f%pars_xy(ind_hc3,j,i)
                        
-!                     IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
-!                          building_pars_f%fill )  THEN 
-!                        surf_usm_v(l)%rho_c_window(nzb_wall,m)   =              &
-!                                           building_pars_f%pars_xy(ind_hc1,j,i) 
-!                        surf_usm_v(l)%rho_c_window(nzb_wall+1,m) =              &
-!                                           building_pars_f%pars_xy(ind_hc1,j,i)
-!                     ENDIF
-!                     IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=               &
-!                          building_pars_f%fill )                                &
-!                        surf_usm_v(l)%rho_c_window(nzb_wall+2,m) =              &
-!                                           building_pars_f%pars_xy(ind_hc2,j,i)
-!                        
-!                     IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=               &
-!                          building_pars_f%fill )                                &
-!                        surf_usm_v(l)%rho_c_window(nzb_wall+3,m) =              &
-!                                           building_pars_f%pars_xy(ind_hc3,j,i)
+                    IF ( building_pars_f%pars_xy(ind_hc1,j,i) /=               &
+                         building_pars_f%fill )  THEN 
+                       surf_usm_v(l)%rho_c_window(nzb_wall,m)   =              &
+                                          building_pars_f%pars_xy(ind_hc1,j,i) 
+                       surf_usm_v(l)%rho_c_window(nzb_wall+1,m) =              &
+                                          building_pars_f%pars_xy(ind_hc1,j,i)
+                    ENDIF
+                    IF ( building_pars_f%pars_xy(ind_hc2,j,i) /=               &
+                         building_pars_f%fill )                                &
+                       surf_usm_v(l)%rho_c_window(nzb_wall+2,m) =              &
+                                          building_pars_f%pars_xy(ind_hc2,j,i)
+                       
+                    IF ( building_pars_f%pars_xy(ind_hc3,j,i) /=               &
+                         building_pars_f%fill )                                &
+                       surf_usm_v(l)%rho_c_window(nzb_wall+3,m) =              &
+                                          building_pars_f%pars_xy(ind_hc3,j,i)
                     
                     IF ( building_pars_f%pars_xy(ind_tc1,j,i) /=               &