Index: /palm/trunk/SOURCE/advec_s_pw.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_pw.f90	(revision 3926)
+++ /palm/trunk/SOURCE/advec_s_pw.f90	(revision 3927)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! pointer attribute removed from scalar 3d-array for performance reasons
+! 
+! 3665 2019-01-10 08:28:24Z raasch
 ! unused variables removed
 ! 
@@ -128,5 +131,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzt
+           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
 
        USE kinds
@@ -142,5 +145,5 @@
        REAL(wp)     ::  gv  !< local additional advective velocity
 
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  sk
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk
  
 
@@ -195,5 +198,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb, nzt
+           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
 
        USE kinds
@@ -209,5 +212,5 @@
        REAL(wp)     ::  gv  !< local additional advective velocity
 
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  sk
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk
 
 
Index: /palm/trunk/SOURCE/advec_s_up.f90
===================================================================
--- /palm/trunk/SOURCE/advec_s_up.f90	(revision 3926)
+++ /palm/trunk/SOURCE/advec_s_up.f90	(revision 3927)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! pointer attribute removed from scalar 3d-array for performance reasons
+! 
+! 3665 2019-01-10 08:28:24Z raasch
 ! unused variables removed
 ! 
@@ -125,5 +128,5 @@
 
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzt
+           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt
 
        USE kinds
@@ -140,5 +143,5 @@
        REAL(wp) ::  wkomp !< advection velocity along z-direction 
 
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  sk !< treated scalar
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !< treated scalar
 
 
@@ -201,5 +204,5 @@
 
        USE indices,                                                            &
-           ONLY:  nzb, nzt
+           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
 
        USE kinds
@@ -216,5 +219,5 @@
        REAL(wp) ::  wkomp !< advection velocity along z-direction 
        
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  sk !< treated scalar
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  sk !< treated scalar
 
 
Index: /palm/trunk/SOURCE/diffusion_s.f90
===================================================================
--- /palm/trunk/SOURCE/diffusion_s.f90	(revision 3926)
+++ /palm/trunk/SOURCE/diffusion_s.f90	(revision 3927)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! pointer attribute removed from scalar 3d-array for performance reasons
+! 
+! 3761 2019-02-25 15:31:42Z raasch
 ! unused variables removed
 ! 
@@ -154,5 +157,5 @@
        
        USE indices,                                                            &
-           ONLY:  nxl, nxr, nyn, nys, nzb, nzt, wall_flags_0
+           ONLY:  nxl, nxlg, nxr, nxrg, nyn, nyng, nys, nysg, nzb, nzt, wall_flags_0
        
        USE kinds
@@ -197,5 +200,5 @@
        REAL(wp), DIMENSION(1:surf_def_h(2)%ns) ::  s_flux_t           !< flux at model top
 
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  s  !< treated scalar
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  s  !< treated scalar
 
 
@@ -483,5 +486,5 @@
        
        USE indices,                                                            &
-           ONLY:  nzb, nzt, wall_flags_0
+           ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt, wall_flags_0
        
        USE kinds
@@ -526,5 +529,5 @@
        REAL(wp), DIMENSION(1:surf_def_h(2)%ns) ::  s_flux_t           !< flux at model top
 
-       REAL(wp), DIMENSION(:,:,:), POINTER ::  s  !< treated scalar
+       REAL(wp), DIMENSION(nzb:nzt+1,nysg:nyng,nxlg:nxrg) ::  s  !< treated scalar
 
 !
Index: /palm/trunk/SOURCE/init_grid.f90
===================================================================
--- /palm/trunk/SOURCE/init_grid.f90	(revision 3926)
+++ /palm/trunk/SOURCE/init_grid.f90	(revision 3927)
@@ -20,9 +20,12 @@
 ! Current revisions:
 ! -----------------
-! Fix bad commit
+! 
 ! 
 ! Former revisions:
 ! -----------------
 ! $Id$
+! Fix bad commit
+! 
+! 3926 2019-04-23 12:56:42Z suehring
 ! Minor bugfix in building mapping when all building IDs in the model domain
 ! are missing