Index: /palm/trunk/SOURCE/bulk_cloud_model_mod.f90
===================================================================
--- /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 3930)
+++ /palm/trunk/SOURCE/bulk_cloud_model_mod.f90	(revision 3931)
@@ -371,5 +371,5 @@
            bcm_header, &
            bcm_actions, &
-           bcm_non_transport_physics, &
+           bcm_non_advective_processes, &
            bcm_exchange_horiz, &
            bcm_prognostic_equations, &
@@ -432,8 +432,8 @@
     END INTERFACE bcm_actions
 
-    INTERFACE bcm_non_transport_physics
-       MODULE PROCEDURE bcm_non_transport_physics
-       MODULE PROCEDURE bcm_non_transport_physics_ij
-    END INTERFACE bcm_non_transport_physics
+    INTERFACE bcm_non_advective_processes
+       MODULE PROCEDURE bcm_non_advective_processes
+       MODULE PROCEDURE bcm_non_advective_processes_ij
+    END INTERFACE bcm_non_advective_processes
 
     INTERFACE bcm_exchange_horiz
@@ -1190,5 +1190,5 @@
 !> Control of microphysics for all grid points
 !------------------------------------------------------------------------------!
-    SUBROUTINE bcm_non_transport_physics
+    SUBROUTINE bcm_non_advective_processes
 
 
@@ -1251,5 +1251,5 @@
        CALL cpu_log( log_point(51), 'microphysics', 'stop' )
 
-    END SUBROUTINE bcm_non_transport_physics
+    END SUBROUTINE bcm_non_advective_processes
 
 
@@ -1260,5 +1260,5 @@
 !------------------------------------------------------------------------------!
 
-    SUBROUTINE bcm_non_transport_physics_ij( i, j )
+    SUBROUTINE bcm_non_advective_processes_ij( i, j )
 
 
@@ -1319,5 +1319,5 @@
        ENDIF
 
-    END SUBROUTINE bcm_non_transport_physics_ij
+    END SUBROUTINE bcm_non_advective_processes_ij
     
     
Index: /palm/trunk/SOURCE/module_interface.f90
===================================================================
--- /palm/trunk/SOURCE/module_interface.f90	(revision 3930)
+++ /palm/trunk/SOURCE/module_interface.f90	(revision 3931)
@@ -20,5 +20,4 @@
 ! Current revisions:
 ! -----------------
-! Changed chem_non_transport_physics to chem_non_advective_processes
 ! 
 ! 
@@ -26,4 +25,7 @@
 ! -----------------
 ! $Id$
+! Changed non_transport_physics to non_advective_processes
+! 
+! 3930 2019-04-24 14:57:18Z forkel
 ! Correct/complete module_interface introduction for chemistry model
 !
@@ -155,5 +157,5 @@
                bcm_header,                                                     &
                bcm_actions,                                                    &
-               bcm_non_transport_physics,                                      &
+               bcm_non_advective_processes,                                    &
                bcm_exchange_horiz,                                             &               
                bcm_prognostic_equations,                                       &
@@ -397,5 +399,5 @@
        module_interface_header,                                                &
        module_interface_actions,                                               &
-       module_interface_non_transport_physics,                                 &
+       module_interface_non_advective_processes,                               &
        module_interface_exchange_horiz,                                        &
        module_interface_prognostic_equations,                                  &
@@ -461,8 +463,8 @@
     END INTERFACE module_interface_actions
 
-    INTERFACE module_interface_non_transport_physics
-       MODULE PROCEDURE module_interface_non_transport_physics
-       MODULE PROCEDURE module_interface_non_transport_physics_ij
-    END INTERFACE module_interface_non_transport_physics
+    INTERFACE module_interface_non_advective_processes
+       MODULE PROCEDURE module_interface_non_advective_processes
+       MODULE PROCEDURE module_interface_non_advective_processes_ij
+    END INTERFACE module_interface_non_advective_processes
     
     INTERFACE module_interface_exchange_horiz
@@ -954,22 +956,22 @@
 ! Description:
 ! ------------
-!> Compute module-specific prognostic_equations (vector-optimized)
-!------------------------------------------------------------------------------!
- SUBROUTINE module_interface_non_transport_physics()
-
-
-    IF ( bulk_cloud_model    )  CALL bcm_non_transport_physics()
+!> Compute module-specificc non_advective_processes (vector-optimized)
+!------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_non_advective_processes()
+
+
+    IF ( bulk_cloud_model    )  CALL bcm_non_advective_processes()
     IF ( air_chemistry       )  CALL chem_non_advective_processes()
 
 
- END SUBROUTINE module_interface_non_transport_physics
-
-
-!------------------------------------------------------------------------------!
-! Description:
-! ------------
-!> Compute module-specific prognostic_equations (cache-optimized)
-!------------------------------------------------------------------------------!
- SUBROUTINE module_interface_non_transport_physics_ij( i, j )
+ END SUBROUTINE module_interface_non_advective_processes
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Compute module-specific non_advective_processes (cache-optimized)
+!------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_non_advective_processes_ij( i, j )
 
 
@@ -978,9 +980,9 @@
 
 
+    IF ( bulk_cloud_model    )  CALL bcm_non_advective_processes( i, j )    
     IF ( air_chemistry       )  CALL chem_non_advective_processes( i, j )
-    IF ( bulk_cloud_model    )  CALL bcm_non_transport_physics( i, j )
-
-
- END SUBROUTINE module_interface_non_transport_physics_ij
+
+
+ END SUBROUTINE module_interface_non_advective_processes_ij
  
 !------------------------------------------------------------------------------!
Index: /palm/trunk/SOURCE/prognostic_equations.f90
===================================================================
--- /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3930)
+++ /palm/trunk/SOURCE/prognostic_equations.f90	(revision 3931)
@@ -447,5 +447,5 @@
     USE module_interface,                                                      &
         ONLY:  module_interface_actions, &
-               module_interface_non_transport_physics, &
+               module_interface_non_advective_processes, &
                module_interface_exchange_horiz, &
                module_interface_prognostic_equations
@@ -544,11 +544,11 @@
        DO  j = nys, nyn
 !
-!--       Calculate non transport physics for all other modules
-          CALL module_interface_non_transport_physics( i, j )
+!--       Calculate non advective processes for all other modules
+          CALL module_interface_non_advective_processes( i, j )
        ENDDO
     ENDDO
 !
-!-- Module Inferface for exchange horiz after non_transport_physics but before
-!-- advection. Therefore, non_transport_physics must not run for ghost points. 
+!-- Module Inferface for exchange horiz after non_advective_processes but before
+!-- advection. Therefore, non_advective_processes must not run for ghost points. 
     CALL module_interface_exchange_horiz()
     !$OMP END PARALLEL
@@ -1218,9 +1218,9 @@
 
 !
-!-- Calculate non transport physics for all other modules
-    CALL module_interface_non_transport_physics
-!
-!-- Module Inferface for exchange horiz after non_transport_physics but before
-!-- advection. Therefore, non_transport_physics must not run for ghost points.     
+!-- Calculate non advective processes for all other modules
+    CALL module_interface_non_advective_processes
+!
+!-- Module Inferface for exchange horiz after non_advective_processes but before
+!-- advection. Therefore, non_advective_processes must not run for ghost points.     
     CALL module_interface_exchange_horiz()
     